Show / Hide Table of Contents

# Class HexView

An hex viewer and editor View over a System.IO.Stream

##### Inheritance

System.Object
Responder
View
HexView

##### Implements

System.Collections.IEnumerable

##### Inherited Members

View.Enter
View.Leave
View.MouseEnter
View.MouseLeave
View.MouseClick
View.Driver
View.Subviews
View.Id
View.IsCurrentTop
View.WantMousePositionReports
View.WantContinuousButtonPressed
View.GetEnumerator()
View.LayoutStyle
View.Bounds
View.X
View.Y
View.Width
View.Height
View.SuperView
View.SetNeedsDisplay()
View.SetNeedsDisplay(Rect)
View.ChildNeedsDisplay()
View.Add(View)
View.Add(View[])
View.RemoveAll()
View.Remove(View)
View.BringSubviewToFront(View)
View.SendSubviewToBack(View)
View.SendSubviewBackwards(View)
View.BringSubviewForward(View)
View.Clear()
View.Clear(Rect)
View.ScreenToView(Int32, Int32)
View.ClipToBounds()
View.SetClip(Rect)
View.DrawFrame(Rect, Int32, Boolean)
View.DrawHotString(ustring, Attribute, Attribute)
View.DrawHotString(ustring, Boolean, ColorScheme)
View.Move(Int32, Int32)
View.HasFocus
View.OnEnter()
View.OnLeave()
View.Focused
View.MostFocused
View.ColorScheme
View.AddRune(Int32, Int32, Rune)
View.ClearNeedsDisplay()
View.DrawContent
View.OnDrawContent(Rect)
View.SetFocus(View)
View.KeyPress
View.ProcessHotKey(KeyEvent)
View.ProcessColdKey(KeyEvent)
View.KeyDown
View.OnKeyDown(KeyEvent)
View.KeyUp
View.OnKeyUp(KeyEvent)
View.EnsureFocus()
View.FocusFirst()
View.FocusLast()
View.FocusPrev()
View.FocusNext()
View.LayoutComplete
View.LayoutSubviews()
View.ToString()
View.OnMouseEnter(MouseEvent)
View.OnMouseLeave(MouseEvent)
View.OnMouseEvent(MouseEvent)
Responder.CanFocus
Responder.MouseEvent(MouseEvent)
System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class HexView : View, IEnumerable

##### Remarks

HexView provides a hex editor on top of a seekable System.IO.Stream with the left side showing an hex dump of the values in the System.IO.Stream and the right side showing the contents (filterd to non-control sequence ASCII characters).

Users can switch from one side to the other by using the tab key.

To enable editing, set AllowEdits to true. When AllowEdits is true the user can make changes to the hexadecimal values of the System.IO.Stream. Any changes are tracked in the Edits property (a System.Collections.Generic.SortedDictionary`2) indicating the position where the changes were made and the new values. A convenience method, ApplyEdits() will apply the edits to the System.IO.Stream.

Control the first byte shown by setting the DisplayStart property to an offset in the stream.

### Constructors

#### HexView()

Initialzies a HexView class using Computed layout.

##### Declaration

    public HexView()

#### HexView(Stream)

Initialzies a HexView class using Computed layout.

##### Declaration

    public HexView(Stream source)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IO.Stream | source | The System.IO.Stream to view and edit as hex, this System.IO.Stream must support seeking, or an exception will be thrown.

### Properties

#### AllowEdits

Gets or sets whether this HexView allow editing of the System.IO.Stream of the underlying System.IO.Stream.

##### Declaration

    public bool AllowEdits { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean | `true` if allow edits; otherwise, `false`.

#### DisplayStart

Sets or gets the offset into the System.IO.Stream that will displayed at the top of the HexView

##### Declaration

    public long DisplayStart { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int64 | The display start.

#### Edits

Gets a System.Collections.Generic.SortedDictionary`2 describing the edits done to the HexView. Each Key indicates an offset where an edit was made and the Value is the changed byte.

##### Declaration

    public IReadOnlyDictionary<long, byte> Edits { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.IReadOnlyDictionary<System.Int64, System.Byte> | The edits.

#### Frame

Gets or sets the frame for the view. The frame is relative to the view's container (SuperView).

##### Declaration

    public override Rect Frame { get; set; }

##### Property Value

Type | Description
--- | ---
Rect | The frame.

##### Overrides

View.Frame

##### Remarks

Change the Frame when using the Absolute layout style to move or resize views.

Altering the Frame of a view will trigger the redrawing of the view as well as the redrawing of the affected regions of the SuperView.

#### Source

Sets or gets the System.IO.Stream the HexView is operating on; the stream must support seeking (System.IO.Stream.CanSeek == true).

##### Declaration

    public Stream Source { get; set; }

##### Property Value

Type | Description
--- | ---
System.IO.Stream | The source.

### Methods

#### ApplyEdits()

This method applies andy edits made to the System.IO.Stream and resets the contents of the Edits property

##### Declaration

    public void ApplyEdits()

#### PositionCursor()

Positions the cursor in the right position based on the currently focused view in the chain.

##### Declaration

    public override void PositionCursor()

##### Overrides

View.PositionCursor()

#### ProcessKey(KeyEvent)

If the view is focused, gives the view a chance to process the keystroke.

##### Declaration

    public override bool ProcessKey(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent | Contains the details about the key that produced the event.

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.ProcessKey(KeyEvent)

##### Remarks

Views can override this method if they are interested in processing the given keystroke. If they consume the keystroke, they must return true to stop the keystroke from being processed by other widgets or consumed by the widget engine. If they return false, the keystroke will be passed using the ProcessColdKey method to other views to process.

The View implementation does nothing but return false, so it is not necessary to call base.ProcessKey if you derive directly from View, but you should if you derive other View subclasses.

#### Redraw(Rect)

Redraws this view and its subviews; only redraws the views that have been flagged for a re-display.

##### Declaration

    public override void Redraw(Rect bounds)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds | The bounds (view-relative region) to redraw.

##### Overrides

View.Redraw(Rect)

##### Remarks

Always use Bounds (view-relative) when calling Redraw(Rect), NOT Frame (superview-relative).

Views should set the color that they want to use on entry, as otherwise this will inherit the last color that was set globaly on the driver.

Overrides of Redraw(Rect) must ensure they do not set `Driver.Clip` to a clip region larger than the `region` parameter.

### Implements

System.Collections.IEnumerable